import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;
/**
 * Write a description of class Blank here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Blank extends World
{
    Player player1 = new Player("Player 1: ");
    Player player2 = new Player("Player 2: ");
    Player dummy = new Player("This score is the discarded values: ");
    Player curr;
    int dir = 0;
    boolean noDir = true;
    static String key;
    static Square[][] grid = new Square[6][6];
    static int lsqx, lsqy;
    int squares = 0;

    /**
     * Constructor for objects of class Blank.
     * 
     */
    public Blank()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        // paint the squares and their X over the numbers so they get the clicks
        setPaintOrder(Square.Highlight.class, Square.class,  Number.class);
        // act the world first for the key getting
        setActOrder(Blank.class);
        prepare();
        Greenfoot.start();
    }

    public void act()
    {
        key = Greenfoot.getKey();
        if (squares == 0) {
            displayGameOver();
        }
        int readied = 0;
        for(Square[] sqs : grid) {
            for(Square s : sqs) {
                if (s.readyState()) {
                    s.hl.highlight();
                    readied++;
                } else {
                    s.hl.unhighlight();
                }
            }
        }
        if (readied == 0 && !noDir && curr != null) {
            // someone got row trapped! swap players
            togglePlayer();
        }
    }

    public void displayGameOver()
    {
        int p1v = player1.getValue();
        int p2v = player2.getValue();
        setBackground(new GreenfootImage("Player " + (p1v > p2v ? "1" : (p2v > p1v ? "2" : "1 and 2")) + " wins. ",
                16, Color.black, Color.white));
        List l = getObjects(Actor.class);
        removeObjects(l);
        addObject(new Label("Score: " + (Math.max(p1v, p2v))), 300-10, 200);
        Greenfoot.stop();
    }
    
    public void togglePlayer() {
        if(curr == null) {
            return;
        }
        setAsCurr(curr == player1 ? player2 : player1);
    }

    public void setAsCurr(Player s)
    {
        if(curr != null)
        {
            curr.drawColor = Color.BLACK;
            curr.updateImage();
        }
        curr = s;
        curr.drawColor = Color.GREEN;
        curr.updateImage();
    }

    public Player getCurrPlayer()
    {
        if (curr == null) {
            return dummy;
        }
        return curr;
    }

    int[] usednum = new int[36];

    public int getRSQNumber() {
        int curr = 0;
        boolean stop = false;
        while(!stop)
        {
            int rand = Greenfoot.getRandomNumber(36)+1;
            if(squares == 36) throw new IllegalStateException("Request for number after all used");
            curr = rand-16;
            stop = true;
            for(int i = 0; i < usednum.length; i++)
            {
                if(usednum[i] == rand)
                {
                    stop = false;
                    break;
                }
            }
            if(stop)
            {
                usednum[squares] = rand;
                squares++;
                break;
            }
        }
        return curr;
    }
    
    /**
     * Returns true if the given square is in a "ready" position
     */
    public boolean readyState(Square s) {
        if (curr == null || noDir) {
            return false;
        }
        boolean directionMatch = false;
        if (curr.dir == Player.Direction.V) {
            directionMatch = s.ix == lsqx;
        } else {
            directionMatch = s.iy == lsqy;
        }
        return directionMatch;
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        for(int x = 1; x < 7; x++)
        {
            for(int y = 1; y < 7; y++)
            {
                Square sq = new Square(x-1,y-1);
                grid[x-1][y-1] = sq;
                addObject(sq, (x*49)+125, y*49);
            }
        }

        addObject(player1, 75, 355);
        addObject(player2, 500, 355);
        Square s = ((Square)getObjects(Square.class).get(Greenfoot.getRandomNumber(36)));
        s.click(true);
    }
}
